require "rails/all"

require "panhara_reports_kit/normalized_params"
require "panhara_reports_kit/base_controller"
require "panhara_reports_kit/cache"
require "panhara_reports_kit/configuration"
require "panhara_reports_kit/engine"
require "panhara_reports_kit/entity"
require "panhara_reports_kit/filters_controller"
require "panhara_reports_kit/form_builder"
require "panhara_reports_kit/helper"
require "panhara_reports_kit/model"
require "panhara_reports_kit/model_configuration"
require "panhara_reports_kit/order"
require "panhara_reports_kit/relative_time"
require "panhara_reports_kit/report_builder"
require "panhara_reports_kit/reports_controller"
require "panhara_reports_kit/utils"
require "panhara_reports_kit/value"
require "panhara_reports_kit/version"

require "panhara_reports_kit/reports/adapters/mysql"
require "panhara_reports_kit/reports/adapters/postgresql"

require "panhara_reports_kit/reports/data/add_table_aggregations"
require "panhara_reports_kit/reports/data/aggregate_composite"
require "panhara_reports_kit/reports/data/aggregate_one_dimension"
require "panhara_reports_kit/reports/data/aggregate_two_dimensions"
require "panhara_reports_kit/reports/data/chart_data_for_data_method"
require "panhara_reports_kit/reports/data/chart_options"
require "panhara_reports_kit/reports/data/format_one_dimension"
require "panhara_reports_kit/reports/data/format_table"
require "panhara_reports_kit/reports/data/format_two_dimensions"
require "panhara_reports_kit/reports/data/generate"
require "panhara_reports_kit/reports/data/generate_for_properties"
require "panhara_reports_kit/reports/data/normalize_properties"
require "panhara_reports_kit/reports/data/populate_one_dimension"
require "panhara_reports_kit/reports/data/populate_two_dimensions"
require "panhara_reports_kit/reports/data/utils"

require "panhara_reports_kit/reports/filter_types/base"
require "panhara_reports_kit/reports/filter_types/boolean"
require "panhara_reports_kit/reports/filter_types/datetime"
require "panhara_reports_kit/reports/filter_types/number"
require "panhara_reports_kit/reports/filter_types/records"
require "panhara_reports_kit/reports/filter_types/string"

require "panhara_reports_kit/reports/abstract_series"
require "panhara_reports_kit/reports/composite_series"
require "panhara_reports_kit/reports/contextual_filter"
require "panhara_reports_kit/reports/dimension"
require "panhara_reports_kit/reports/dimension_with_series"
require "panhara_reports_kit/reports/filter"
require "panhara_reports_kit/reports/filter_with_series"
require "panhara_reports_kit/reports/generate_autocomplete_results"
require "panhara_reports_kit/reports/generate_autocomplete_method_results"
require "panhara_reports_kit/reports/inferrable_configuration"
require "panhara_reports_kit/reports/model_settings"
require "panhara_reports_kit/reports/properties"
require "panhara_reports_kit/reports/properties_to_filter"
require "panhara_reports_kit/reports/series"

class PanharaReportsKit
  def self.configure
    yield(configuration)
  end

  def self.configuration
    @configuration ||= Configuration.new
  end

  def self.parse_date_range(string)
    PanharaReportsKit::Reports::Data::Utils.parse_date_range(string)
  end

  def self.format_date_range(string)
    PanharaReportsKit::Reports::Data::Utils.format_date_range(string)
  end
end
